package modality;
import java.awt.Dialog;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.SwingUtilities;

public class ApplicationModalDialogWithExcludeDemo {
    private static void constructGUI() {
        final JFrame parent1 = new JFrame("Parent Frame 1");
        parent1.setLayout(new FlowLayout());
        parent1.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        JButton button = new JButton("Show modal dialog");
        button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                JDialog dialog = new JDialog(parent1, 
                        "Application-Modal Dialog", 
                        Dialog.ModalityType.APPLICATION_MODAL);
                dialog.setBounds(300, 200, 300, 150);
                dialog.setVisible(true);
            }
        });
        parent1.add(button);
        parent1.setBounds(100, 100, 200, 150);
        parent1.setVisible(true);

        // the second frame, affected by the modality of dialog
        JFrame parent2 = new JFrame("Parent Frame 2");
        parent2.setBounds(500, 100, 300, 150);
        parent2.setVisible(true);

        // the third frame, excluded from the modality of dialog
        JFrame parent3 = new JFrame("Parent Frame 3 - Excluded");
        parent3.setBounds(300, 400, 300, 150);
        parent3.setModalExclusionType(
                Dialog.ModalExclusionType.APPLICATION_EXCLUDE);
        parent3.setVisible(true);
    }
    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                constructGUI();
            }
        });
    }
}